﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "AICharacter.h"
#include "BehaviorTree/BehaviorTree.h"
#include "GameFramework/Character.h"
#include "EnemyCharacter.generated.h"

UCLASS()
class ENDLESSVENDETTA_API AEnemyCharacter : public AAICharacter
{
	GENERATED_BODY()

public:
	// Sets default values for this character's properties
	AEnemyCharacter();

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;
	class AAIControlHub* DelegatedControlHub;

public:
	// Called every frame
	virtual void Tick(float DeltaTime) override;
	void SubscribeToGroupAIEvents(class AAIControlHub* ControlHub);
	void SetLocalAlertLevel(int NewAlertLevel) const;
	
private:
	FDelegateHandle AlertLevelDelegateHandle;
	FDelegateHandle HuntPlayerDelegateHandle;
	void SetAlertLevel(int NewAlertLevel) const;
	void HuntPlayer(FVector PlayerLastKnowLocation);
};
